const execa = require('execa');

module.exports.cli = async (cmd, ...args) => {
  try {
    return await execa(cmd, [...args], { stdio: 'inherit' });
  } catch (err) {
    console.log(`failed to run ${cmd} ${args.join(' ')}`);
    console.log(`${err.message}`);
    throw err;
  }
};

module.exports.commandInDir = (cwd = null) => async (cmd, ...args) => {
  try {
    return await execa(
      cmd,
      [...args],
      { stdio: 'inherit', cwd },
    );
  } catch (err) {
    console.log(`failed to run ${cmd} ${args.join(' ')}`);
    console.log(`${err.message}`);
    throw err;
  }
};

module.exports.testCommand = async cmd => {
  try {
    return await execa('which', [cmd], { stdio: 'inherit' });
  } catch (err) {
    console.log(`command '${cmd}' not found`);
    console.log(`${err.message}`);
    return null
  }
}
