const tar = require('tar');
const fetch = require('node-fetch');
const path = require('path');
const getWritableDirectory = require('@now/build-utils/fs/get-writable-directory.js');
const { cli, commandInDir } = require('./cli');
const installRubyToolchain = require('./apt-install-ruby')

async function getRuby(cwd) {
	console.log('downloading ruby.........')
  const rbInstallerUrl = 'https://github.com/postmodern/ruby-install/archive/v0.7.0.tar.gz'
  const res = await fetch(rbInstallerUrl)

  if (!res.ok) {
    throw new Error(`Failed to download: ${rbInstallerUrl}`);
  }

  return new Promise((resolve, reject) => {
    console.log("In Promise")
    res.body
      .on('error', reject)
      .pipe(tar.extract({ cwd, gzip: true }))
      .on('finish', () => resolve(path.join(cwd, 'ruby-install-0.7.0')))
  })
}

async function installRuby(cwd, version) {
  const executor = commandInDir(cwd)
  // sudo make install
  await executor('make', 'install')

  // await cli('ruby-install',  '--system', 'ruby', version)// '--system', '--latest')

  return cli('ruby', '-v')
}


module.exports = async (version = null) => {
  console.log(`received version: ${version}`)
  version = version || '2.5.5'
  const dir = await getWritableDirectory()
  try {
    // await installRubyToolchain()
    // const installerPath = await getRuby(dir)
    // console.log('After download')
    // await installRuby(installerPath, version)
    // console.log('After compile')
    // sudo amazon-linux-extras install ruby2.4
    // await cli('sudo', 'amazon-linux-extras', 'install', 'ruby2.5')
  }
  catch (err){
    console.log(err)
    throw err
  }
}