const path = require('path');
const { cli, commandInDir } = require('./cli');

const bundle = (command, wkdir) => async (...options) => {
  await commandInDir(wkdir)('bundle', ...[command, ...options]);
};

const symlink = mainDir => async (mirroredDir) => {
  await cli('sudo', 'ln', '-s', mainDir, mirroredDir);
};

// [ '/var/lib/gems/2.5.0', '/root/.gem/ruby/2.5.0' ]
const gemPath = async () => {
  const cmds = 'gem env | grep INSTALLATION'.split(' ');
  // $ rbenv exec gem environment | grep INSTALLATION
  let paths = await cli(...cmds);
  paths = paths.stdout.split('\n');
  console.log(paths)
  return paths.map(
    pat => pat.match(/.*INSTALLATION.*?:\s(\/.+\/\.?gem[s]?\/.+)/)[1],
  );
};

const cleaner = parentDir => async childDir => await commandInDir(parentDir)('rm', '-rf', childDir)

module.exports = async (srcPath, ...args) => {
  // srcPath = path.dirname(srcPath)
  console.log(srcPath)
  const config = bundle('config', srcPath);
  // process.chdir(srcPath)
  console.log('Installing your dependencies.....');
  await cli('gem', 'i', 'bundler', "--no-document");
  await config('without', 'development:test:ci');
  await config('auto_install', 'true');
  await bundle('install', srcPath)()

  // pack all required gem with app 
  await bundle('install', srcPath)(...args) // '--deployment' 
  // await bundle('package', srcPath)('--all');

  // CelanUp to have lean app
  await cleaner(srcPath)(path.join('vendor', 'cache'))
  await cleaner(srcPath)('.bundle')

  // symlink project's gems to avoid having to download gem after redeployment
  // const systemGemDirs = await gemPath();
  // const linkGemPath = await symlink(dir);
  // systemGemDirs.map(linkGemPath);
  console.log('Dependencies installed correctly.....');
};
