require 'webrick'
require 'json'
require 'net/http'
require 'uri'

require_relative '__NOW_HANDLER_FILE'

module NowHandler

  def self.now_handler(event:, context:)
    thread = Thread.new do
      server = WEBrick::HTTPServer.new :Port => 3000
      if Object.const_defined?('Handler')
        puts 'Handler called'
        server.mount '/', Handler
      end
      trap('INT') { server.stop }
      server.start
    end
    # thread.join
    puts "event: #{event} and context: #{context}"
    payload = JSON.parse event['body']
    path = payload['path']
    headers = payload['headers']
    http_method = payload['method']

    uri = URI("http://0.0.0.0:3000#{path}")

    res = Net::HTTP.start uri.host, uri.port do |http|
      req = Kernel.const_get("Net::HTTP::#{http_method.capitalize}").new(uri)
      headers.each {|k,v| req[k] = v}
      http.request req
    end

    {
      statusCode: res.code,
      headers: res.each_capitalized,
      body: res.body
    }

  end
end

# if __FILE__ == $PROGRAM_NAME
#   NowHandler.now_handler ARGV
# end